#################################
# Login and password management #
#################################

stdHelp ='''This is zulkbot version %s
----------------------
Standard commands are:
 login <password> [nick] - Login as the nick you are using or specified nick
 logout                  - logout from the bot
 pass <password>         - change password
 op <channel>            - get op in channel (you will need channel op status i bot)'''%progVer

adminHelp ='''Admin commands:
 rawIRC <command>        - send raw irc command
 join <channel>          - makes bot join channel
 part <channel>          - makes bot part channel
 adduser <nick>          - add a user with specified nick
 deluser <nick>          - remove specified user
 sethost <nick> <host>   - set host for user
 delhost <nick>          - remove host for user'''

ownerHelp ='''Owner commands:
 raw <command>           - run python command
 quit                    - makes the bot quit
 confReload              - Reload configuration
 addgroup <nick> <group> - add user to group
 delgroup <nick> <group> - remove user from group'''

if cmdDict.has_key('target'):
	if cmdDict.has_key('text'):
		command = cmdDict['text'].split(' ',1)
		if command[0] == 'login':
			if len(command) > 1:
				param = command[1].split()
				if len(param) == 1:
					if secLogin(cmdDict['nick'],cmdDict['nick'],param[0],cmdDict['host']):
						SAY(cmdDict['back'],'Logged in')
					else:
						SAY(cmdDict['back'],'Wrong password or nick')
				elif len(param) > 1:
					if secLogin(param[1],cmdDict['nick'],param[0],cmdDict['host']):
						SAY(cmdDict['back'],'Logged in')
					else:
						SAY(cmdDict['back'],'Wrong password or nick')	

		if command[0] == 'logout':
			if secAuth(cmdDict['nick']):
				secLogout(cmdDict['nick'])
				SAY(cmdDict['nick'],'You are now logged out')


		if command[0] == 'pass':
			if secAuth(cmdDict['nick']):
				if len(command) > 1:
					secChangePass(cmdDict['nick'],command[1].split()[0])
					SAY(cmdDict['back'],'Password changed')
					secSaveConf()

		if command[0] == 'help':
			for a in stdHelp.split('\n'):
				SAY(cmdDict['nick'],a)
			if secAuth(cmdDict['nick']):
				if secInGroup(cmdDict['nick'],'admin'):
					for a in adminHelp.split('\n'):
						SAY(cmdDict['nick'],a)
				if secInGroup(cmdDict['nick'],'owner'):
					for a in ownerHelp.split('\n'):
						SAY(cmdDict['nick'],a)

