##########################
# Common security script #
##########################

import re
global chanOPs,secAuth,secLogin,secLogout,secAddUser,secDelUser,secAddGroup,secDelGroup,secInGroup,secNickChange,secSaveConf,secLoadConf,secAddOP,secDelOP,secBotOP,secChangePass

secConf = '.zulkbot.security.config'

authUsers = ['local']
userMapp = {'local nick':'local'}
authHosts = {'local':'^me@not possible$','TheZulk':'.*'}
authUserPass = [['local','qwe'],['TheZulk','hejsan'],['lithis','longman'],['slvmnd','kardborre']] 
userGroups = {	'local':['admin','owner'],
		'TheZulk':['op','aop','admin','owner'],
		'lithis':['op','admin']}


def secSaveConf():
	global secConf,authUserPass,userGroups,authHoss,chanOPs,onConnect
	secFile = open(secConf,'w')
	pickle.dump(authUserPass,secFile)
	pickle.dump(userGroups,secFile)
	pickle.dump(authHosts,secFile)
	pickle.dump(chanOPs,secFile)
	pickle.dump(onConnect,secFile)
	secFile.close()

def secLoadConf():
	global secConf,authUserPass,userGroups,authHoss,chanOPs,onConnect
	if exists(secConf):
		secFile = open(secConf)
		authUserPass = pickle.load(secFile)
		userGroups = pickle.load(secFile)
		authHosts = pickle.load(secFile)
		chanOPs = pickle.load(secFile)
		onConnect = pickle.load(secFile)
		secFile.close()


def secAuth(nick):
	global authUsers,userMapp
	if not userMapp.has_key(nick):
		return 0
	if userMapp[nick] not in authUsers:
		return 0
	return 1

def secLogin(user,nick,passwd,host):
	global authUsers,authUserPass,userMapp,authHosts
	if userMapp.has_key(user):
		if userMapp[user] == nick:
			return 1
	print 'User: "'+user+'" Password: "'+passwd+'"'
	for i in authUserPass:	
		if i[0] == user:
			if i[1] == passwd:
				if authHosts.has_key(user):
					if not re.match(authHosts[user],host):
						return 0
				authUsers.append(user)
				userMapp[nick] = user
				print 'Login passed all tests'
				return 1
	return 0

def secLogout(nick):
	global authUsers,userMapp
	if userMapp.has_key(nick):
		if userMapp[nick] in authUsers:
			authUsers.remove(userMapp[nick])
		del userMapp[nick]

def secAddUser(nick,passwd):
	global authUsers,authUserPass
	authUsers.append(nick)
	userMapp[nick] = nick
	authUserPass.append([nick,passwd])

def secDelUser(nick):
	global authUserPass
	secLogout(nick)
	authUserPass = filter((lambda x: x[0] != nick),authUserPass)
		
def secAddHost(user,host):
	authHosts[user]=host

def secDelHost(user):
	if authHosts.has_key(user):
		del authHosts[user]

def secChangePass(nick,passwd):
	for i in authUserPass:
		if i[0] == userMapp[nick]:
			i[1] = passwd

def secAddGroup(nick,group):
	global userGroups
	if userGroups.has_key(nick):
		userGroups[nick].append(group)
	else:
		userGroups[nick] = [group]
	secSaveConf()

def secDelGroup(nick,group):
	global userGroups
	if userGroups.has_key(nick):
		if group in userGroups[nick]:
			userGroups['nick'].remove(group)

def secInGroup(nick,group):
	global userGroups,userMapp
	if userMapp.has_key(nick):
		if userGroups.has_key(userMapp[nick]):
			if group in userGroups[userMapp[nick]]:
				return 1
	return 0

def secNickChange(oldNick,newNick):
	global userMapp
	print userMapp
	print oldNick +':'+newNick
	if userMapp.has_key(oldNick):
		userMapp[newNick]=userMapp[oldNick]
		del userMapp[oldNick]
		print 'Changing "'+oldNick+'" to "'+newNick+'"'

def secAddOP(chan,user):
	if chan in chanOPs.keys():
		if not user in chanOPs[chan]:
			chanOPs[chan].append(user)
	else:
		chanOPs[chan] = [user]

def secDelOP(chan,user):
	if chan in chanOPs.keys():
		if user in chanOPs[chan]:
			chanOPs[chan].remove(user)

def secBotOP(chan,nick):
	if userMapp.has_key(nick):
		if chanOPs.has_key(chan):
			if userMapp[nick] in chanOPs[chan]:
				return 1
	return 0

secLoadConf()
